/****************************************************************************************/
/*  StBODY.C                                                                            */
/*                                                                                      */
/*  Author: Alejandro F. Reimondo                                                       */
/*  Description: Visual Smalltalk extesions to standard API.                            */
/*                                                                                      */
/****************************************************************************************/

#include "stBody.h"

GENESISAPI geBody *GENESISCC stBody_Create(void)
{
	return geBody_Create();
}

GENESISAPI void GENESISCC stBody_Destroy(geBody **B)
{
	geBody_Destroy(B);
}

GENESISAPI geBoolean GENESISCC stBody_IsValid(const geBody *B)
{
	return geBody_IsValid(B);
}
	
GENESISAPI geBoolean GENESISCC stBody_GetGeometryStats(const geBody *B, int lod, int *Vertices, int *Faces, int *Normals)
{
	return geBody_GetGeometryStats(B,lod,Vertices,Faces,Normals);
}

GENESISAPI geBoolean GENESISCC stBody_AddFace(	geBody *B,
		const geVec3d *Vertex1, const geVec3d *Normal1, 
		geFloat U1, geFloat V1, int BoneIndex1,
		const geVec3d *Vertex2, const geVec3d *Normal2, 
		geFloat U2, geFloat V2, int BoneIndex2,
		const geVec3d *Vertex3, const geVec3d *Normal3, 
		geFloat U3, geFloat V3, int BoneIndex3,
		int MaterialIndex)
{
	return geBody_AddFace( B,
		Vertex1,Normal1,U1,V1,BoneIndex1,
		Vertex2,Normal2,U2,V2,BoneIndex2,
		Vertex3,Normal3,U3,V3,BoneIndex3,
		MaterialIndex);
}

GENESISAPI geBoolean GENESISCC stBody_AddMaterial( geBody *B, 
		const char *MaterialName, geBitmap *Bitmap,
		geFloat Red, geFloat Green, geFloat Blue,
		int *MaterialIndex)
{
	return geBody_AddMaterial(B,
		MaterialName,Bitmap,
		Red, Green, Blue,
		MaterialIndex);
}

GENESISAPI geBoolean GENESISCC stBody_GetMaterial(const geBody *Body, int MaterialIndex,
		const char **MaterialName,
		geBitmap **Bitmap, geFloat *Red, geFloat *Green, geFloat *Blue)
{
	return geBody_GetMaterial(
		Body,MaterialIndex,
		MaterialName,Bitmap,
		Red,Green,Blue);
}

GENESISAPI geBoolean GENESISCC stBody_SetMaterial(geBody *Body, int MaterialIndex,
		geBitmap *Bitmap,  geFloat Red,  geFloat Green,  geFloat Blue)
{
	return geBody_SetMaterial(
		Body,MaterialIndex,Bitmap,
		Red,Green,Blue);
}

GENESISAPI int GENESISCC stBody_GetMaterialCount(const geBody *B)
{
	return geBody_GetMaterialCount(B);
}

GENESISAPI geBoolean GENESISCC stBody_AddBone( geBody *B, 
		int ParentBoneIndex,
		const char *BoneName, 
		const geXForm3d *AttachmentMatrix,
		int *BoneIndex)
{
	return geBody_AddBone(B,
		ParentBoneIndex, BoneName, 
		AttachmentMatrix,BoneIndex);
}

GENESISAPI geBoolean GENESISCC stBody_ComputeLevelsOfDetail( geBody *B ,int Levels)
{
	return geBody_ComputeLevelsOfDetail(B ,Levels);
}

GENESISAPI int GENESISCC stBody_GetBoneCount(const geBody *B)
{
	return geBody_GetBoneCount(B);
}

GENESISAPI void GENESISCC stBody_GetBone(	const geBody *B, 
		int BoneIndex, 
		const char **BoneName,
		geXForm3d *Attachment, 
		int *ParentBoneIndex)
{
	geBody_GetBone(
		B, BoneIndex, BoneName,
		Attachment, ParentBoneIndex);
}

GENESISAPI int32 GENESISCC stBody_GetBoneNameChecksum(const geBody *B)
{
	return geBody_GetBoneNameChecksum(B);
}

GENESISAPI void GENESISCC stBody_SetBoundingBox( geBody *B,
		int BoneIndex,
		const geVec3d *MinimumBoxCorner,
		const geVec3d *MaximumBoxCorner)
{
	geBody_SetBoundingBox(
		B,BoneIndex,
		MinimumBoxCorner,MaximumBoxCorner);
}
 
GENESISAPI geBoolean GENESISCC stBody_GetBoundingBox( const geBody *B, 
		int BoneIndex,
		geVec3d *MinimumBoxCorner,
		geVec3d *MaximumBoxCorner)
{
	return geBody_GetBoundingBox(
		B,BoneIndex,
		MinimumBoxCorner,MaximumBoxCorner);
}

GENESISAPI geBoolean GENESISCC stBody_GetBoneByName(const geBody* B,
	const char* BoneName,
	int* pBoneIndex,
	geXForm3d* Attachment,
	int* pParentBoneIndex)
{
	return geBody_GetBoneByName(
		B,BoneName,pBoneIndex,
		Attachment,pParentBoneIndex);
}

GENESISAPI geBoolean GENESISCC stBody_WriteToFile(const geBody *B, geVFile *pFile)
{
	return geBody_WriteToFile(B,pFile);
}

GENESISAPI geBody  *GENESISCC  stBody_CreateFromFile(geVFile *pFile)
{
	return geBody_CreateFromFile(pFile);
}