/****************************************************************************************/
/*  StExtBox.C                                                                          */
/*                                                                                      */
/*  Author: Alejandro F. Reimondo                                                       */
/*  Description: Visual Smalltalk extesions to standard API.                            */
/*                                                                                      */
/****************************************************************************************/

#include "StExtBox.h"


GENESISAPI void GENESISCC stExtBox_Set ( geExtBox *B,
		 geFloat X1, geFloat Y1, geFloat Z1,
		 geFloat X2, geFloat Y2, geFloat Z2 )
{
	geExtBox_Set (B,X1,Y1,Z1,X2,Y2,Z2);
}

GENESISAPI geBoolean GENESISCC stExtBox_IsValid(  const geExtBox *B )
{
	return geExtBox_IsValid(B);
}

GENESISAPI void GENESISCC stExtBox_SetToPoint ( geExtBox *B, const geVec3d *Point )
{
	geExtBox_SetToPoint (B,Point);
}

GENESISAPI GENESISAPI void GENESISCC stExtBox_ExtendToEnclose( geExtBox *B, const geVec3d *Point )
{
	geExtBox_ExtendToEnclose(B,Point);
}

GENESISAPI geBoolean GENESISCC stExtBox_Intersection ( const geExtBox *B1, const geExtBox *B2, geExtBox *Result	)
{
	return geExtBox_Intersection (B1,B2,Result);
}

GENESISAPI void GENESISCC stExtBox_Union ( const geExtBox *B1, const geExtBox *B2, geExtBox *Result )
{
	geExtBox_Union (B1,B2,Result);
}

GENESISAPI geBoolean GENESISCC stExtBox_ContainsPoint ( const geExtBox *B, const geVec3d  *Point )
{
	return geExtBox_ContainsPoint (B,Point);
}

GENESISAPI void GENESISCC stExtBox_GetTranslation ( const geExtBox *B,       geVec3d *pCenter )
{
	geExtBox_GetTranslation (B,pCenter);
}

GENESISAPI void GENESISCC stExtBox_SetTranslation ( geExtBox *B, const geVec3d *pCenter )
{
	geExtBox_SetTranslation (B,pCenter);
}

GENESISAPI void GENESISCC stExtBox_Translate ( geExtBox *B, geFloat DX, geFloat DY, geFloat DZ )
{
	geExtBox_Translate (B,DX,DY,DZ);
}

GENESISAPI void GENESISCC stExtBox_GetScaling ( const geExtBox *B, geVec3d *pScale )
{
	geExtBox_GetScaling (B,pScale);
}

GENESISAPI void GENESISCC stExtBox_SetScaling ( geExtBox *B, const geVec3d *pScale )
{
	geExtBox_SetScaling (B,pScale);
}

GENESISAPI void GENESISCC stExtBox_Scale ( geExtBox *B, geFloat DX, geFloat DY,geFloat DZ )
{
	geExtBox_Scale (B,DX,DY,DZ);
}

GENESISAPI void GENESISCC stExtBox_LinearSweep(	const geExtBox *BoxToSweep, 
		const geVec3d *StartPoint, 
		const geVec3d *EndPoint, 
		geExtBox *EnclosingBox )
{
	geExtBox_LinearSweep (BoxToSweep,StartPoint,EndPoint,EnclosingBox);
}

GENESISAPI geBoolean GENESISCC stExtBox_RayCollision(
		const geExtBox *B, const geVec3d *Start, const geVec3d *End, 
		geFloat *T, geVec3d *Normal )
{
	return geExtBox_RayCollision(B,Start,End,T,Normal);
}
