/****************************************************************************************/
/*  StExtBox.H                                                                          */
/*                                                                                      */
/*  Author: Alejandro F. Reimondo	                                                    */
/*  Description: Visual Smalltalk extesions to standard API.	                        */
/*                                                                                      */
/****************************************************************************************/
#ifndef StExtBox_H
#define StExtBox_H 

#include "ExtBox.h"

#ifdef __cplusplus
extern "C" {
#endif

GENESISAPI void GENESISCC stExtBox_Set ( geExtBox *B,
		 geFloat X1, geFloat Y1, geFloat Z1,
		 geFloat X2, geFloat Y2, geFloat Z2 );

GENESISAPI geBoolean GENESISCC stExtBox_IsValid(  const geExtBox *B );
GENESISAPI void GENESISCC stExtBox_SetToPoint ( geExtBox *B, const geVec3d *Point );
GENESISAPI GENESISAPI void GENESISCC stExtBox_ExtendToEnclose( geExtBox *B, const geVec3d *Point );
GENESISAPI geBoolean GENESISCC stExtBox_Intersection ( const geExtBox *B1, const geExtBox *B2, geExtBox *Result	);
GENESISAPI void GENESISCC stExtBox_Union ( const geExtBox *B1, const geExtBox *B2, geExtBox *Result );
GENESISAPI geBoolean GENESISCC stExtBox_ContainsPoint ( const geExtBox *B, const geVec3d  *Point );
GENESISAPI void GENESISCC stExtBox_GetTranslation ( const geExtBox *B,       geVec3d *pCenter );
GENESISAPI void GENESISCC stExtBox_SetTranslation (       geExtBox *B, const geVec3d *pCenter );
GENESISAPI void GENESISCC stExtBox_Translate      (       geExtBox *B, geFloat DX, geFloat DY, geFloat DZ );

GENESISAPI void GENESISCC stExtBox_GetScaling     ( const geExtBox *B,       geVec3d *pScale );
GENESISAPI void GENESISCC stExtBox_SetScaling     (       geExtBox *B, const geVec3d *pScale );
GENESISAPI void GENESISCC stExtBox_Scale          (       geExtBox *B, geFloat DX, geFloat DY,geFloat DZ );

GENESISAPI void GENESISCC stExtBox_LinearSweep(	const geExtBox *BoxToSweep, 
		const geVec3d *StartPoint, 
		const geVec3d *EndPoint, 
		geExtBox *EnclosingBox );

GENESISAPI geBoolean GENESISCC stExtBox_RayCollision(
		const geExtBox *B, const geVec3d *Start, const geVec3d *End, 
		geFloat *T, geVec3d *Normal );


#ifdef __cplusplus
}
#endif

#endif
					