/****************************************************************************************/
/*  StQuatern.C                                                                         */
/*                                                                                      */
/*  Author: Alejandro F. Reimondo                                                       */
/*  Description: Visual Smalltalk extesions to standard API.                            */
/*                                                                                      */
/****************************************************************************************/

#include "StQuatern.h"


GENESISAPI geBoolean GENESISCC stQuaternion_IsValid( const geQuaternion *Q )
{
	return geQuaternion_IsValid(Q);
}

GENESISAPI void GENESISCC stQuaternion_Set( geQuaternion *Q, geFloat W, geFloat X, geFloat Y, geFloat Z)
{
	geQuaternion_Set(Q,W,X,Y,Z);
}

GENESISAPI void GENESISCC stQuaternion_SetVec3d( geQuaternion *Q, geFloat W, const geVec3d *V)
{
	geQuaternion_SetVec3d(Q,W,V);
}

GENESISAPI geBoolean GENESISCC stQuaternion_GetAxisAngle(const geQuaternion *Q, geVec3d *Axis, geFloat *Theta)
{
	return geQuaternion_GetAxisAngle(Q,Axis,Theta);
}

GENESISAPI void GENESISCC stQuaternion_Get( const geQuaternion *Q, geFloat *W, geFloat *X, geFloat *Y, geFloat *Z)
{
	geQuaternion_Get(Q,W,X,Y,Z);
}

GENESISAPI void GENESISCC stQuaternion_GetVec3d( const geQuaternion *Q, geFloat *W, geVec3d *V)
{
	geQuaternion_GetVec3d(Q,W,V);
}

GENESISAPI void GENESISCC stQuaternion_FromMatrix(const geXForm3d	*RotationMatrix, geQuaternion *QDest)
{
	geQuaternion_FromMatrix(RotationMatrix,QDest);
}

GENESISAPI void GENESISCC stQuaternion_Slerp(const geQuaternion *Q0, const geQuaternion *Q1, geFloat T, geQuaternion *QT)
{
	geQuaternion_Slerp(Q0,Q1,T,QT);
}

GENESISAPI void GENESISCC stQuaternion_SlerpNotShortest( const geQuaternion *Q0, const geQuaternion *Q1, geFloat T, geQuaternion *QT)
{
	geQuaternion_SlerpNotShortest(Q0,Q1,T,QT);
}

GENESISAPI void GENESISCC stQuaternion_Multiply( const geQuaternion *Q1, const geQuaternion *Q2, geQuaternion *QProduct)
{
	geQuaternion_Multiply(Q1,Q2,QProduct);
}

GENESISAPI void GENESISCC stQuaternion_Rotate( const geQuaternion *Q, const geVec3d *V, geVec3d *VRotated)
{
	geQuaternion_Rotate(Q,V,VRotated);
}

GENESISAPI geBoolean GENESISCC stQuaternion_IsUnit(const geQuaternion *Q)
{
	return geQuaternion_IsUnit(Q);
}

GENESISAPI void GENESISCC stQuaternion_SetNoRotation(geQuaternion *Q)
{
	geQuaternion_SetNoRotation(Q);
}

GENESISAPI void GENESISCC stQuaternion_Ln(const geQuaternion *Q, geQuaternion *LnQ)
{
	geQuaternion_Ln(Q,LnQ);
}

GENESISAPI void GENESISCC stQuaternion_Exp(const geQuaternion *Q,geQuaternion *ExpQ)
{
	geQuaternion_Exp(Q,ExpQ);
}

GENESISAPI void GENESISCC stQuaternion_Scale(const geQuaternion *Q,geFloat Scale,geQuaternion *QScaled)
{
	geQuaternion_Scale(Q,Scale,QScaled);
}

GENESISAPI void GENESISCC stQuaternion_Add(const geQuaternion *Q1,const geQuaternion *Q2,geQuaternion *QSum)
{
	geQuaternion_Add(Q1,Q2,QSum);
}

GENESISAPI void GENESISCC stQuaternion_Subtract(const geQuaternion *Q1, const geQuaternion *Q2, geQuaternion *QSum)
{
	geQuaternion_Subtract(Q1,Q2,QSum);
}

GENESISAPI void GENESISCC stQuaternion_Inverse(const geQuaternion *Q, geQuaternion *QInv)
{
	geQuaternion_Inverse(Q,QInv);
}

GENESISAPI geFloat GENESISCC stQuaternion_Magnitude(const geQuaternion *Q)
{
	return geQuaternion_Magnitude(Q);
}

GENESISAPI geBoolean GENESISCC stQuaternion_Compare( geQuaternion *Q1, geQuaternion *Q2, geFloat Tolerance )
{
	return geQuaternion_Compare(Q1,Q2,Tolerance);
}

