/****************************************************************************************/
/*  StQuatern.H                                                                         */
/*                                                                                      */
/*  Author: Alejandro F. Reimondo	                                                    */
/*  Description: Visual Smalltalk extesions to standard API.	                        */
/*                                                                                      */
/****************************************************************************************/
#ifndef StQuatern_H
#define StQuatern_H 

#include "Quatern.h"

#ifdef __cplusplus
extern "C" {
#endif

GENESISAPI geBoolean GENESISCC stQuaternion_IsValid( const geQuaternion *Q );
GENESISAPI void GENESISCC stQuaternion_Set( geQuaternion *Q, geFloat W, geFloat X, geFloat Y, geFloat Z);
GENESISAPI void GENESISCC stQuaternion_SetVec3d( geQuaternion *Q, geFloat W, const geVec3d *V);
GENESISAPI GENESISAPI void GENESISCC stQuaternion_SetFromAxisAngle(geQuaternion *Q, const geVec3d *Axis, geFloat Theta);
GENESISAPI geBoolean GENESISCC stQuaternion_GetAxisAngle(const geQuaternion *Q, geVec3d *Axis, geFloat *Theta);
GENESISAPI void GENESISCC stQuaternion_Get( const geQuaternion *Q, geFloat *W, geFloat *X, geFloat *Y, geFloat *Z);
GENESISAPI void GENESISCC stQuaternion_GetVec3d( const geQuaternion *Q, geFloat *W, geVec3d *V);
GENESISAPI void GENESISCC stQuaternion_FromMatrix(const geXForm3d	*RotationMatrix, geQuaternion *QDest);
GENESISAPI GENESISAPI void GENESISCC stQuaternion_ToMatrix(const geQuaternion	*Q,  geXForm3d	*RotationMatrixDest);
GENESISAPI void GENESISCC stQuaternion_Slerp(const geQuaternion *Q0, const geQuaternion *Q1, geFloat T, geQuaternion *QT);
GENESISAPI void GENESISCC stQuaternion_SlerpNotShortest( const geQuaternion *Q0, const geQuaternion *Q1, geFloat T, geQuaternion *QT);
GENESISAPI void GENESISCC stQuaternion_Multiply( const geQuaternion *Q1, const geQuaternion *Q2, geQuaternion *QProduct);
GENESISAPI void GENESISCC stQuaternion_Rotate( const geQuaternion *Q, const geVec3d *V, geVec3d *VRotated);
GENESISAPI geBoolean GENESISCC stQuaternion_IsUnit(const geQuaternion *Q);
GENESISAPI GENESISAPI geFloat GENESISCC stQuaternion_Normalize(geQuaternion *Q);
GENESISAPI GENESISAPI void GENESISCC stQuaternion_Copy(const geQuaternion *QSrc, geQuaternion *QDst);
GENESISAPI void GENESISCC stQuaternion_SetNoRotation(geQuaternion *Q);
GENESISAPI void GENESISCC stQuaternion_Ln(const geQuaternion *Q, geQuaternion *LnQ);
GENESISAPI void GENESISCC stQuaternion_Exp(const geQuaternion *Q,geQuaternion *ExpQ);
GENESISAPI void GENESISCC stQuaternion_Scale(const geQuaternion *Q,geFloat Scale,geQuaternion *QScaled);
GENESISAPI void GENESISCC stQuaternion_Add(const geQuaternion *Q1,const geQuaternion *Q2,geQuaternion *QSum);
GENESISAPI void GENESISCC stQuaternion_Subtract(const geQuaternion *Q1, const geQuaternion *Q2, geQuaternion *QSum);
GENESISAPI void GENESISCC stQuaternion_Inverse(const geQuaternion *Q, geQuaternion *QInv);
GENESISAPI geFloat GENESISCC stQuaternion_Magnitude(const geQuaternion *Q);
GENESISAPI geBoolean GENESISCC stQuaternion_Compare( geQuaternion *Q1, geQuaternion *Q2, geFloat Tolerance );

#ifdef __cplusplus
}
#endif

#endif
					